/*****************************************************************************
Spartan S3 Starter Kit to Parallel Port Interface
  Verilog Module
  
  Provides an W_IN-bit input bus inti and a W_OUT-bit output bus into by
  allowing an external host to control three internal registers. 
  
  Will not work for less than one input or output.
  
  Written by Eirik Bakke, January 14, 2006
  See http://www.mit.edu/~ebakke/parint for documentation
  
******************************************************************************/

module Parint(tdi, tck, tms, tdo, inti, into);
	parameter W_IN  = 4;
	parameter W_OUT = 4;
	
	input  tdi, tck, tms;
	output tdo;
	output [W_IN-1:0] inti;
	input  [W_OUT-1:0] into;
	reg [W_OUT-1:0] piso;
	reg [W_IN-1:0] sipo;
	reg [W_IN-1:0] sipobuf;

   assign inti = sipobuf;
   assign tdo  = piso[0];
	
	always @ (posedge tck)
	begin
	   if (tms) begin
			piso    = into;
			sipobuf = sipo;
		end else begin
			piso = piso >> 1;
			sipo = sipo >> 1;
			sipo[W_IN-1] = tdi;
		end
	end
endmodule
